 function [MA_]=MA_simul(M_,MA_,options_,oo_)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% MA_simul.m
%
% This file calculates simulation(s) convoluting the Volterra kernels 
% calculated in kernels.m with a sequence of random shocks and compares the
% first simulation with the simulation produced by dynare in a plot
% 
%Included in the package nonlinear_MA
%
%THIS VERSION: 1.0.1 October 12, 201
%
%Copyright: Hong Lan and Alexander Meyer-Gohde
%
%You are free to use/modify/redistribute this program so long as original
%authorship credit is given and you in no way impinge on its free
%distribution
%This software is provided as is with no guarantees of any kind
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

S=oo_.exo_simul';
MA_.simul_first(:,1)=MA_.BETA_1*S(:,1);
if options_.order>=2
MA_.simul_second(:,1)=MA_.BETA_1*S(:,1)+(1/2)*MA_.BETA_2*kron([zeros(M_.endo_nbr,1);S(:,1)],[zeros(M_.endo_nbr,1);S(:,1)]);
if options_.order==3
 MA_.simul_first_sigma_2(:,1)=(1/6)*MA_.BETA_sigma_sigma_1*[zeros(M_.endo_nbr,1);S(:,1)];
MA_.simul_third(:,1)=MA_.BETA_1*S(:,1)+(1/2)*MA_.BETA_2*kron([zeros(M_.endo_nbr,1);S(:,1)],[zeros(M_.endo_nbr,1);S(:,1)])...
    +(1/6)*MA_.BETA_3_1*kron([zeros(M_.endo_nbr,1);S(:,1)],kron([zeros(M_.endo_nbr,1);S(:,1)],[zeros(M_.endo_nbr,1);S(:,1)]))...
    +MA_.BETA_3_3*kron([zeros(M_.endo_nbr,1);S(:,1)],[zeros(M_.endo_nbr,1);(1/2)*kron([zeros(M_.endo_nbr,1);S(:,1)],[zeros(M_.endo_nbr,1);S(:,1)])])...
    +MA_.simul_first_sigma_2(:,1);

end
end
for t=2:options_.periods
    MA_.simul_first(:,t)=MA_.ALPHA*MA_.simul_first(:,t-1)+MA_.BETA_1*S(:,t);
if options_.order>=2
MA_.simul_second(:,t)=MA_.ALPHA*MA_.simul_second(:,t-1)+MA_.BETA_1*S(:,t)+(1/2)*MA_.BETA_2*kron([MA_.simul_first(:,t-1);S(:,t)],[MA_.simul_first(:,t-1);S(:,t)]);
if options_.order==3
    MA_.simul_first_sigma_2(:,t)=(1/6)*MA_.BETA_sigma_sigma_1*[MA_.simul_first(:,t-1);S(:,t)];
MA_.simul_third(:,t)=MA_.ALPHA*MA_.simul_third(:,t-1)+MA_.BETA_1*S(:,t)+(1/2)*MA_.BETA_2*kron([MA_.simul_first(:,t-1);S(:,t)],[MA_.simul_first(:,t-1);S(:,t)])...
    +(1/6)*MA_.BETA_3_1*kron([MA_.simul_first(:,t-1);S(:,t)],kron([MA_.simul_first(:,t-1);S(:,t)],[MA_.simul_first(:,t-1);S(:,t)]))...
    +MA_.BETA_3_3*kron([MA_.simul_first(:,t-1);S(:,t)],[MA_.simul_second(:,t-1)-MA_.simul_first(:,t-1);(1/2)*kron([MA_.simul_first(:,t-1);S(:,t)],[MA_.simul_first(:,t-1);S(:,t)])])...
    +MA_.simul_first_sigma_2(:,t);

end
end
end



for ii=1:M_.endo_nbr
    
    if options_.order==1
MA_.simul_total(ii,:)=MA_.simul_first(ii,:)+oo_.dr.ys(ii);
if MA_.plot_simulations==1
  figure('Units','characters','Position',[1 1 240 70]);
    plot(1+options_.drop:options_.periods,MA_.simul_total(ii,1+options_.drop:end),'b')
    eval(sprintf('title(''Simulation of %s'')',M_.endo_names(ii,:)))
     ylabel('Value');
    xlabel('Periods');
    legend({'First-Order Accurate'},'Location','Best')
end
    elseif options_.order==2
        MA_.simul_total(ii,:)=oo_.dr.ys(ii)+MA_.Y_sigma_2(ii)+MA_.simul_second(ii,:);
        if MA_.plot_simulations==1
        figure('Units','characters','Position',[1 1 240 70]);
    plot(1+options_.drop:options_.periods,MA_.simul_total(ii,1+options_.drop:end),'b',1+options_.drop:options_.periods,MA_.simul_first(ii,1+options_.drop:end)+oo_.dr.ys(ii),'b-.',1+options_.drop:options_.periods,oo_.endo_simul(ii,1+options_.drop:options_.periods),'k--')
    eval(sprintf('title(''Simulation of %s'')',M_.endo_names(ii,:)))
     ylabel('Value');
    xlabel('Periods');
    if options_.pruning==1
    legend({'Second-Order Accurate','First-Order Accurate','Dynare: Pruned Second Order'},'Location','Best')
    else
    legend({'Second-Order Accurate','First-Order Accurate','Dynare: Second Order'},'Location','Best')
    end
 
        end 
        
    elseif options_.order==3
                MA_.simul_total(ii,:)=oo_.dr.ys(ii)+MA_.Y_sigma_2(ii)+MA_.simul_third(ii,:);
                if MA_.plot_simulations==1
        figure('Units','characters','Position',[1 1 240 70]);
     plot(1+options_.drop:options_.periods,MA_.simul_total(ii,1+options_.drop:end),'b',1+options_.drop:options_.periods,oo_.dr.ys(ii)+MA_.Y_sigma_2(ii)+MA_.simul_second(ii,1+options_.drop:end),'b--',1+options_.drop:options_.periods,MA_.simul_first(ii,1+options_.drop:end)+oo_.dr.ys(ii),'b-.',1+options_.drop:options_.periods,oo_.endo_simul(ii,1+options_.drop:options_.periods),'k--')
    eval(sprintf('title(''Simulation of %s'')',M_.endo_names(ii,:)))
     ylabel('Value');
    xlabel('Periods');
    legend({'Third-Order Accurate','Second-Order Accurate','First-Order Accurate','Dynare: Third Order'},'Location','Best')
  
                end
        
      
    end
end

if MA_.simulation_nbr>1
    MA_.mult_simul{1}=MA_.simul_total;
    for jj=2:MA_.simulation_nbr
        
        S=chol(M_.Sigma_e,'lower')*randn(M_.exo_nbr,options_.periods);
S=mat2cell(S,M_.exo_nbr,ones(1,options_.periods))';
if options_.order>=2
     [ia,ib]=meshgrid(1:M_.exo_nbr,1:M_.exo_nbr);
     [ja,jb]=meshgrid(1,1);
S1=repmat( S, [ 1 options_.periods]);
S2=repmat( permute(S,[2 1]), [ options_.periods 1]);
SS= cellfun(@(x,y) repeated_kron(x,y,ia,ib,ja,jb), S1, S2,'UniformOutput',false);
if options_.order==3
     [iaa,ibb]=meshgrid(1:M_.exo_nbr,1:M_.exo_nbr^2);
     [jaa,jbb]=meshgrid(1,1);
SS1=repmat( S1, [1 1 options_.periods]);
SS2=repmat( permute(SS, [3 1 2]), [ options_.periods 1 1]);
SSS=cellfun(@(x,y) repeated_kron(x,y,iaa,ibb,jaa,jbb), SS1, SS2, 'UniformOutput',false);
end
end
clear S2 S1 SS2 SS1

for j=1:options_.periods
   temp= cellfun(@mtimes, MA_.Y_i(1:options_.periods-j+1)',S(j:options_.periods),'UniformOutput',false);
   MA_.simul_first(:,options_.periods-j+1)= sum([temp{:}],2);
   if options_.order>=2
   temp=cellfun(@mtimes, MA_.Y_ji(1:options_.periods-j+1,1:options_.periods-j+1),SS(j:options_.periods,j:options_.periods),'UniformOutput',false);
   MA_.simul_second(:,options_.periods-j+1)= sum([temp{:}],2);
   if options_.order==3
   temp= cellfun(@mtimes, MA_.Y_sigma_2_i(1:options_.periods-j+1)',S(j:options_.periods),'UniformOutput',false);
   MA_.simul_first_sigma_2(:,options_.periods-j+1)= sum([temp{:}],2);
   %temp=cellfun(@mtimes, MA_.Y_kji(1:options_.periods-j+1,1:options_.periods-j+1,1:options_.periods-j+1),SSS(j:options_.periods,j:options_.periods,j:options_.periods),'UniformOutput',false);
   %MA_.simul_third(:,options_.periods-j+1)= sum([temp{:}],2);
   MA_.simul_third(:,options_.periods-j+1)=zeros(M_.endo_nbr,1);
   for ii1=1:options_.periods-j+1
       for ii2=1:options_.periods-j+1
           for ii3=1:options_.periods-j+1
               MA_.simul_third(:,options_.periods-j+1)=MA_.simul_third(:,options_.periods-j+1)+MA_.Y_kji{ii1,ii2,ii3}*SSS{j-1+ii1,j-1+ii2,j-1+ii3};
           end
       end
   end
   for ii=1:M_.endo_nbr
   MA_.mult_simul{jj}(ii,:)=MA_.simul_first(ii,:)+oo_.dr.ys(ii)+MA_.Y_sigma_2(ii)+MA_.simul_second(ii,:)+MA_.simul_third(ii,:)+MA_.simul_first_sigma_2(ii,:);
   end
   else
       for ii=1:M_.endo_nbr
        MA_.mult_simul{jj}(ii,:)=MA_.simul_first(ii,:)+oo_.dr.ys(ii)+MA_.Y_sigma_2(ii)+MA_.simul_second(ii,:);
        end
   end
   else
       for ii=1:M_.endo_nbr
        MA_.mult_simul{jj}(ii,:)=MA_.simul_first(ii,:)+oo_.dr.ys(ii);
        end
   end
end




    end
end