function [MA_]=calculate_irfs(M_,MA_,options_,oo_)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% calculate_irfs.m
%
% This file calulates IRF's
% 
%Included in the package nonlinear_MA
%
%THIS VERSION: 1.0.1 October 12, 201
%
%Copyright: Hong Lan and Alexander Meyer-Gohde
%
%You are free to use/modify/redistribute this program so long as original
%authorship credit is given and you in no way impinge on its free
%distribution
%This software is provided as is with no guarantees of any kind
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if MA_.calculate_kernels==1 && MA_.max_kernel_length>=options_.irf

%first_order
temp = cat(3,MA_.Y_i{:});
if options_.order==3
temp_3 = cat(3,MA_.Y_sigma_2_i{:});
end
for jj=1:M_.exo_nbr
MA_.irf.first((jj-1)*M_.endo_nbr+[1:M_.endo_nbr],:)=squeeze(temp(:,jj,:));
if options_.order==3
MA_.irf.first_sigma_2((jj-1)*M_.endo_nbr+[1:M_.endo_nbr],:)=squeeze(temp_3(:,jj,:));
end
end


if options_.order>=2
temp = cat(3,MA_.Y_ji{:,:});
for jj=1:M_.exo_nbr
temp_2 = reshape(squeeze(temp(:,(jj-1)*M_.exo_nbr+jj,:,:)), [M_.endo_nbr, MA_.max_length, MA_.max_length]);
for ii=1:M_.endo_nbr
    %Save the diagonal component for construnction of combined impulse response
    MA_.irf.second((jj-1)*M_.endo_nbr+ii,:)=diag(squeeze(temp_2(ii,:,:)))';
end
end
if options_.order==3
%assemble the third-order impulse components
temp = cat(3,MA_.Y_kji{:,:,:});
for jj=1:M_.exo_nbr
for ii=1:M_.endo_nbr
    temp_2=reshape(squeeze(temp(ii,(jj-1)*M_.exo_nbr^2+(jj-1)*M_.exo_nbr+jj,:)), [MA_.max_length, MA_.max_length, MA_.max_length]);
    MA_.irf.third((jj-1)*M_.endo_nbr+ii,:)=temp_2([0:MA_.max_length-1]*(MA_.max_length)^2+[0:MA_.max_length-1]*MA_.max_length+[1:MA_.max_length]);
end
end
end
end


else
    
  MA_.max_length=  options_.irf;
  %first_order
   MA_.Y_i_irf{1}=MA_.BETA_1;%linear irf at impact
for i=2:MA_.max_length%iterating through the recursion for the linear irf
    MA_.Y_i_irf{i}=MA_.ALPHA*MA_.Y_i_irf{i-1};
end
temp = cat(3,MA_.Y_i_irf{:});
if options_.order==3
     MA_.Y_sigma_2_i_irf{1}=(1/2)*MA_.BETA_sigma_sigma_1*[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)];
                                           
     for i=2:MA_.max_length
       MA_.Y_sigma_2_i_irf{i}=MA_.ALPHA*MA_.Y_sigma_2_i_irf{i-1}+(1/2)*MA_.BETA_sigma_sigma_1*[MA_.Y_i_irf{i-1};zeros(M_.exo_nbr,M_.exo_nbr)];
         end 
temp_3 = cat(3,MA_.Y_sigma_2_i_irf{:});
end


for jj=1:M_.exo_nbr
MA_.irf.first((jj-1)*M_.endo_nbr+[1:M_.endo_nbr],:)=squeeze(temp(:,jj,:));
if options_.order==3
MA_.irf.first_sigma_2((jj-1)*M_.endo_nbr+[1:M_.endo_nbr],:)=squeeze(temp_3(:,jj,:));
end
end

if options_.order>=2

    MA_.Y_ji_irf{1}=(1/2)*MA_.BETA_2*kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)]);
    for j=2:MA_.max_length
        MA_.Y_ji_irf{j}=MA_.ALPHA*MA_.Y_ji_irf{j-1}+(1/2)*MA_.BETA_2*kron([MA_.Y_i_irf{j-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_i_irf{j-1};zeros(M_.exo_nbr,M_.exo_nbr)]);
      
    end
temp = cat(3,MA_.Y_ji_irf{:});
for jj=1:M_.exo_nbr
MA_.irf.second((jj-1)*M_.endo_nbr+[1:M_.endo_nbr],:)=squeeze(temp(:,(jj-1)*M_.exo_nbr+jj,:));
end

if options_.order==3
%assemble the third-order impulse components
K_matrix=commutation(M_.exo_nbr,M_.exo_nbr^2)*kron(eye(M_.exo_nbr),commutation(M_.exo_nbr,M_.exo_nbr));
     %DkronDkronD=kron(D,DkronD);
     MA_.Y_kji_irf{1}=(1/6)*MA_.BETA_3*...
         [kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)]));...
         kron([zeros(M_.endo_nbr,M_.exo_nbr^2);kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)])],[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)]);...
         kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr^2);kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)])])*K_matrix;...
          kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr^2);kron([zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)],[zeros(M_.endo_nbr,M_.exo_nbr);eye(M_.exo_nbr)])])];
     for k=2:MA_.max_length
        
                  MA_.Y_kji_irf{k}=MA_.ALPHA*MA_.Y_kji_irf{k-1}+(1/6)*MA_.BETA_3*...
                    [kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)]));...
                     kron([MA_.Y_ji_irf{k-1};kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)])],[MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)]);...
                    kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_ji_irf{k-1};kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)])])*K_matrix;...
                    kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_ji_irf{k-1};kron([MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)],[MA_.Y_i_irf{k-1};zeros(M_.exo_nbr,M_.exo_nbr)])])];
 
     end


temp = cat(3,MA_.Y_kji_irf{:});
for jj=1:M_.exo_nbr
MA_.irf.third((jj-1)*M_.endo_nbr+[1:M_.endo_nbr],:)=squeeze(temp(:,(jj-1)*M_.exo_nbr^2+(jj-1)*M_.exo_nbr+jj,:));
end
end
end  
end