 function [MA_]=plots_irf(M_,MA_,options_,oo_)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% plots_irf.m
%
% This file produces plots of the IRF's calculated in calculate_irfs
% 
%Included in the package nonlinear_MA
%
%THIS VERSION: 1.0.1 October 12, 201
%
%Copyright: Hong Lan and Alexander Meyer-Gohde
%
%You are free to use/modify/redistribute this program so long as original
%authorship credit is given and you in no way impinge on its free
%distribution
%This software is provided as is with no guarantees of any kind
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


 

irf_length_vector=1:options_.irf;
for jj=1:M_.exo_nbr
for ii=1:M_.endo_nbr
    
    if options_.order==1
     MA_.irf.total((jj-1)*M_.endo_nbr+ii,:)=MA_.irf.first((jj-1)*M_.endo_nbr+ii,:)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2);
  figure('Units','characters','Position',[1 1 240 70]);
    plot(irf_length_vector-1,MA_.irf.total((jj-1)*M_.endo_nbr+ii,irf_length_vector),'b')
    eval(sprintf('title(''Impulse Response of %s to a %s Std. Dev. Shock in %s'')',M_.endo_names(ii,:),num2str((MA_.shock_scale)),M_.exo_names(jj,:)))
     ylabel('Deviations');
    xlabel('Periods since Shock Realization');
    legend({'First-Order Accurate'},'Location','Best')
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
    
    elseif options_.order==2
     MA_.irf.total((jj-1)*M_.endo_nbr+ii,:)=MA_.irf.first((jj-1)*M_.endo_nbr+ii,:)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2)+MA_.irf.second((jj-1)*M_.endo_nbr+ii,:)*((MA_.shock_scale^2)*M_.Sigma_e(jj,jj));
    figure('Units','characters','Position',[1 1 240 70]);
    subplot(3,3,[1:6]); plot([irf_length_vector-1],MA_.irf.total((jj-1)*M_.endo_nbr+ii,irf_length_vector),'b',[irf_length_vector-1],MA_.irf.first((jj-1)*M_.endo_nbr+ii,irf_length_vector)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2),'b-.')
    eval(sprintf('title(''Impulse Response of %s to a %s Std. Dev. Shock in %s'')',M_.endo_names(ii,:),num2str((MA_.shock_scale)),M_.exo_names(jj,:)))
    ylabel('Deviations');
    xlabel('Periods since Shock Realization');
    legend({'Second-Order Accurate','First-Order Accurate'},'Location','Best')
    hold on
     plot([irf_length_vector-1],repmat(0, [1 options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
     subplot(3,3,[7]); plot([irf_length_vector-1],MA_.irf.first((jj-1)*M_.endo_nbr+ii,irf_length_vector)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2),'b')
    title('First-Order Component')
    ylabel('Deviations');
    xlabel('Periods');
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
      subplot(3,3,[8]); plot([irf_length_vector-1],MA_.irf.second((jj-1)*M_.endo_nbr+ii,irf_length_vector)*((MA_.shock_scale^2)*M_.Sigma_e(jj,jj)),'b')
    title('Second-Order Component')
    ylabel('Deviations');
    xlabel('Periods');
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
      subplot(3,3,[9]); plot([irf_length_vector-1],repmat(oo_.dr.ys(ii), [1 options_.irf]),'b',[irf_length_vector-1],repmat(oo_.dr.ys(ii)+MA_.Y_sigma_2(ii), [1 options_.irf]),'b-.')
    title('Steady-State and Constant')
    legend({'Steady-State','plus Risk Adjutsment'},'Location','Best')
    
    elseif options_.order==3
    MA_.irf.total((jj-1)*M_.endo_nbr+ii,:)=(MA_.irf.first((jj-1)*M_.endo_nbr+ii,:)+MA_.irf.first_sigma_2((jj-1)*M_.endo_nbr+ii,:))*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2)+MA_.irf.second((jj-1)*M_.endo_nbr+ii,:)*((MA_.shock_scale^2)*M_.Sigma_e(jj,jj))+MA_.irf.third((jj-1)*M_.endo_nbr+ii,:)*(MA_.shock_scale^3)*(M_.Sigma_e(jj,jj))^(3/2);
    figure('Units','characters','Position',[1 1 240 70]);
    subplot(4,3,[1:6]); plot([irf_length_vector-1],MA_.irf.total((jj-1)*M_.endo_nbr+ii,irf_length_vector),'b',[irf_length_vector-1],MA_.irf.first((jj-1)*M_.endo_nbr+ii,irf_length_vector)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2)+MA_.irf.second((jj-1)*M_.endo_nbr+ii,irf_length_vector)*((MA_.shock_scale^2)*M_.Sigma_e(jj,jj)),'b--',[irf_length_vector-1],MA_.irf.first((jj-1)*M_.endo_nbr+ii,irf_length_vector)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2),'b-.')
    eval(sprintf('title(''Impulse Response of %s to a %s Std. Dev. Shock in %s'')',M_.endo_names(ii,:),num2str((MA_.shock_scale)),M_.exo_names(jj,:)))
    ylabel('Deviations');
    xlabel('Periods since Shock Realization');
    legend({'Third-Order Accurate','Second-Order Accurate','First-Order Accurate'},'Location','Best')
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
     subplot(4,3,[7]); plot([irf_length_vector-1],MA_.irf.first((jj-1)*M_.endo_nbr+ii,irf_length_vector)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2),'b')
    title('First-Order Component')
    ylabel('Deviations');
    xlabel('Periods');
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
      subplot(4,3,[8]); plot([irf_length_vector-1],MA_.irf.second((jj-1)*M_.endo_nbr+ii,irf_length_vector)*((MA_.shock_scale^2)*M_.Sigma_e(jj,jj)),'b')
    title('Second-Order Component')
    ylabel('Deviations');
    xlabel('Periods');
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
          subplot(4,3,[10]); plot([irf_length_vector-1],MA_.irf.first_sigma_2((jj-1)*M_.endo_nbr+ii,irf_length_vector)*MA_.shock_scale*(M_.Sigma_e(jj,jj))^(1/2),'b')
    title('Risk Correction to First-Order')
    ylabel('Deviations');
    xlabel('Periods');
    hold on
     plot([0:options_.irf-1],repmat(0, [options_.irf]),'k-')
     hold off
    set(gca,'xlim',[0 options_.irf])
      subplot(4,3,[11]); plot([irf_length_vector-1],MA_.irf.third((jj-1)*M_.endo_nbr+ii,irf_length_vector)*(MA_.shock_scale^3)*(M_.Sigma_e(jj,jj))^(3/2),'b')
    title('Third-Order Component')
    ylabel('Deviations');
    xlabel('Periods');
    hold on
     plot([irf_length_vector-1],repmat(0, [options_.irf]),'k-')
     hold off
     set(gca,'xlim',[0 options_.irf])
      subplot(4,3,[9]); plot([irf_length_vector-1],repmat(oo_.dr.ys(ii), [1 options_.irf]),'b',[irf_length_vector-1],repmat(oo_.dr.ys(ii)+MA_.Y_sigma_2(ii), [1 options_.irf]),'b-.')
    title('Steady-State and Constant')
    legend({'Steady-State','plus Risk Adjustment'},'Location','Best')
    set(gca,'xlim',[0 options_.irf])
    end
end
end