function x=sylvester_doubling_eye(b,dim,c2,d,cond)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% sylvester_doubling_eye.m
%
% This file solves iteratively x+d=bx(eye(dim) kron c2) using d as an 
% initial guess.
% 
% Adapted from sylvestera.m from Dynare (original copyright below) and 
% order2guts.m from gensys2 see Chris Sims's webpage at:
% http://sims.princeton.edu/yftp/gensys2/gensys2/order2guts.m
%
%Included in the package nonlinear_MA
%
%THIS VERSION: 1.0.1 October 12, 201
%
%Copyright: Hong Lan and Alexander Meyer-Gohde
%
%You are free to use/modify/redistribute this program so long as original
%authorship credit is given and you in no way impinge on its free
%distribution
%This software is provided as is with no guarantees of any kind
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Copyright (C) 2005-2009 Dynare Team
%
% This file is part of Dynare.
%
% Dynare is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% Dynare is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with Dynare.  If not, see <http://www.gnu.org/licenses/>.
x0=-d;
e = 1;
iter = 1;
if issparse(b)==1 || issparse(d)==1 || issparse(c2)==1
    c1=speye(dim);
else
    c1=eye(dim);
end
while e > cond && iter < 500
    x = x0+b*x0*kron(c1,c2);
    e = max(max(abs(x-x0)));
    x0 = x;
    c2=c2^2;
    b=b^2;
    iter = iter + 1;
end
if iter == 500
    warning('sylvester3_doubling : Only accuracy of %10.8f is achieved after 500 iterations') 
end